if not ClosetGnome or not BigWigs then return end

-------------------------------------------------------------------------------
-- Localization                                                              --
-------------------------------------------------------------------------------

local al = LibStub("AceLocale-3.0")
do
	do
		local L = al:NewLocale("CGBW", "enUS", true)
		L["addon_desc"] = "Makes your ClosetGnome aware of the various boss monsters in this dangerous world.\n\nAfter assigning a set to a boss, ClosetGnome will automatically equip that set when the relevant boss module is enabled in Big Wigs, allowing you to automate such tasks as equipping the right resistance/stamina/DPS sets and so forth.\n\n"
		L["BigWigs module %s enabled, equipping set %s."] = true

		L["%s has been enabled. Do you want to equip %s?\n\nYou can disable this confirmation dialog to autoequip with /cgbw confirm."] = true
		L["Equip"] = true
		L["Cancel"] = true
		
		L["Aliases"] = true
		L["Set"] = true
		L["Select which set to alias to a boss."] = true
		L["Boss"] = true
		L["Select which boss to alias the selected set to."] = true
		L["Add"] = true
		L["Alias the selected set to the selected boss."] = true
		L["Confirm Autoequip"] = true
		L["Open a confirmation dialog before autoequipping a boss set."] = true

		L["%s: %s."] = true
	end
	do
		local L = al:NewLocale("CGBW", "koKR")
		if L then
			L["BigWigs module %s enabled, equipping set %s."] = "빅윅 모듈 %s|1이;가 활성화 되었습니다. %s 세트를 착용합니다."
			L["ClosetGnome - BigWigs"] = "ClosetGnome - BigWigs"
			L["Makes your ClosetGnome aware of the various boss monsters in this dangerous world."] = "던전이나 레이드 중에 각 몬스터에 맞게 장비세트를 자동으로 착용합니다."

			L["%s has been enabled. Do you want to equip %s?\n\nYou can disable this confirmation dialog to autoequip with /cgbw confirm."] = "%s가 활성화 되었습니다. %s 세트를 착용하시겠습니까?\n\n장비 세트 착용 확인 알림창을 /cgbw confirm를 입력하여 끌 수 있습니다."
			L["Equip"] = "장착"
			L["Cancel"] = "취소"

			L["Alias"] = "이름"
			L["Alias a BigWigs bossmod to an existing set, or reset an alias by not including the set parameter."] = "기존의 세트에 빅윅 보스 모드의 이름을 설정합니다. 그렇지 않으면 세트 파라미터를 포함하지 않음으로 이름을 다시 설정합니다."
			L["<boss> <set>"] = "<보스> <세트>"
			L["ListAliases"] = "세트리스트"
			L["List aliases"] = "세트 리스트"
			L["List the current aliases."] = "현재 저장한 세트 리스트를 봅니다."
			L["Registered aliases (uppercased module: set name):"] = "이름 등록 (어퍼 케이스 모듈: 세트 이름):"
			L["Alias %s removed."] = "이름 %s 제거"
			L["Confirm"] = "확인"
			L["Confirm Autoequip"] = "자동 착용 확인"
			L["Open a confirmation dialog before autoequipping a boss set."] = "보스전시에 자동 장착하기 전에 확인창을 엽니다."
			L["List modules"] = "모듈 리스트"
			L["ListModules"] = "모듈리스트"
			L["List the loaded BigWigs modules that can be assigned to a set."] = "빅윅 모듈에 맞는 세트 리스트를 불러옵니다."
			L["Available boss modules:"] = "가능한 보스 모듈:"

			L["%s aliased to %s."] = "%s aliased to %s."
			L["%s: %s."] = "%s: %s."
			L["%d aliases registered."] = "%d 이름을 등록했습니다."
		end
	end
	do
		local L = al:NewLocale("CGWB", "esES")
		if L then
			L["BigWigs module %s enabled, equipping set %s."] = "M\195\179dulo BigWigs %s activado, equipando el conjunto %s."
			L["ClosetGnome - BigWigs"] = "ClosetGnome - BigWigs"
			L["Makes your ClosetGnome aware of the various boss monsters in this dangerous world."] = "Hace que tu ClosetGnome est\195\169 al tanto de los varios monstruos boss que hay en este peligroso mundo."

			L["%s has been enabled. Do you want to equip %s?\n\nYou can disable this confirmation dialog to autoequip with /cgbw confirm."] = "%s ha sido activado. \194\191Quieres equipar %s?\n\nPUedes desactivar esta ventana de confirmaci\195\179n para autoequiparte con /cgbw confirm."
			L["Equip"] = "Equipar"
			L["Cancel"] = "Cancelar"

			L["Alias"] = "Alias"
			L["Alias a BigWigs bossmod to an existing set, or reset an alias by not including the set parameter."] = "Crea un alias de un BigWigs bossmod hacia un conjunto existente, o reinicia un alias al no incluir el par\195\161metro de conjunto"
			L["<boss> <set>"] = "<boss> <conjunto>"
			L["ListAliases"] = "ListarAlias"
			L["List aliases"] = "Listar alias"
			L["List the current aliases."] = "Muestra una lista con los alias actuales."
			L["Registered aliases (uppercased module: set name):"] = "Alias registrados (m\195\179dulo en may\195\186sculas: nombre del conjunto):"
			L["Alias %s removed."] = "Alias %s eliminado."
			L["Confirm"] = "Confirmar"
			L["Confirm Autoequip"] = "Confirmar Autoequipado"
			L["Open a confirmation dialog before autoequipping a boss set."] = "Abre una ventana de confirmaci\195\179n antes de autoequiparte con un conjunto de boss."
			L["List modules"] = "Listar m\195\179dulos"
			L["ListModules"] = "ListarModulos"
			L["List the loaded BigWigs modules that can be assigned to a set."] = "Muestra una lista de los m\195\179dulos BigWigs cargados a los que puedes asignar un conjunto."
			L["Available boss modules:"] = "M\195\179dulos de boss disponibles:"

			L["%s aliased to %s."] = "Creado alias de %s para %s"
			L["%s: %s."] = "%s: %s."
			L["%d aliases registered."] = "%d alias registrados."
		end
	end
end

-------------------------------------------------------------------------------
-- Locals                                                                    --
-------------------------------------------------------------------------------

local queuedSet = nil
local BB = nil
local L = al:GetLocale("CGBW")

-- indexed tables, sorted
local bossModules = {}
local cgSets = {}

local selectedModule = nil
local selectedSet = nil

-------------------------------------------------------------------------------
-- Addon                                                                     --
-------------------------------------------------------------------------------

local addon = {}

local options = nil -- Forward declaration
local updateAliases = nil
local reservedOptionKeys = {
	cgbwDesc = true,
	confirm = true,
	header = true,
	set = true,
	boss = true,
	add = true,
	spacer = true,
}
local function removeAlias(info)
	addon.db.char.alias[info[1]] = nil
	updateAliases()
end
function updateAliases()
	for k, v in pairs(options.args) do
		if not reservedOptionKeys[k] then
			v.hidden = true
		end
	end
	for boss, set in pairs(addon.db.char.alias) do
		if options.args[boss] then
			options.args[boss].hidden = nil
		else
			options.args[boss] = {
				type = "execute",
				name = L["%s: %s."]:format(boss, set),
				desc = "Click to remove this alias.",
				order = 100,
				func = removeAlias,
				width = "full",
			}
		end
	end
end

options = {
	type = "group",
	handler = addon,
	args = {
		cgbwDesc = {
			type = "description",
			name = L["addon_desc"],
			order = 1,
		},
		confirm = {
			type = "toggle",
			name = L["Confirm Autoequip"],
			desc = L["Open a confirmation dialog before autoequipping a boss set."],
			get = function() return addon.db.profile.confirmEquip end,
			set = function(info, v) addon.db.profile.confirmEquip = v end,
			order = 2,
		},
		header = {
			type = "header",
			name = L["Aliases"],
			order = 3,
		},
		set = {
			type = "select",
			name = L["Set"],
			desc = L["Select which set to alias to a boss."],
			values = cgSets,
			get = function() return selectedSet end,
			set = function(_, value) selectedSet = value end,
			order = 4,
			width = "half",
		},
		boss = {
			type = "select",
			name = L["Boss"],
			desc = L["Select which boss to alias the selected set to."],
			disabled = function() return not selectedSet end,
			values = bossModules,
			get = function() return selectedModule end,
			set = function(_, value) selectedModule = value end,
			order = 5,
		},
		add = {
			type = "execute",
			name = L["Add"],
			desc = L["Alias the selected set to the selected boss."],
			disabled = function() return not selectedSet or not selectedModule end,
			func = function()
				addon.db.char.alias[bossModules[selectedModule]] = cgSets[selectedSet]
				selectedModule = nil
				selectedSet = nil
				updateAliases()
			end,
			order = 6,
			width = "half",
		},
		spacer = {
			type = "description",
			name = "",
			order = 10,
		},
	},
}

local function updateBossModules()
	for i in pairs(bossModules) do bossModules[i] = nil end
	for name, module in BigWigs:IterateModules() do
		if module:IsBossModule() and module.zonename then
			tinsert(bossModules, name)
		end
	end
	table.sort(bossModules)
end

local function updateSets()
	for i in pairs(cgSets) do cgSets[i] = nil end
	for k in pairs(ClosetGnome.db.char.set) do
		tinsert(cgSets, k)
	end
	table.sort(cgSets)
	local changed = nil
	for boss, set in pairs(addon.db.char.alias) do
		if not ClosetGnome.db.char.set[set] then
			addon.db.char.alias[boss] = nil
			changed = true
		end
	end
	if changed then updateAliases() end
end

local function init()
	local defaults = {
		profile = {
			confirmEquip = true,
		},
		char = {
			alias = {},
		},
	}
	addon.db = LibStub("AceDB-3.0"):New("ClosetGnomeBigWigsDB", defaults)

	updateBossModules()
	updateSets()

	LibStub("AceConfig-3.0"):RegisterOptionsTable("ClosetGnome-BigWigs", options)
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ClosetGnome-BigWigs", "Big Wigs", "ClosetGnome")

	AceLibrary("AceEvent-2.0"):embed(addon)

	addon:RegisterEvent("BigWigs_RecvSync")
	addon:RegisterEvent("BigWigs_ModuleRegistered", function(name)
		local m = BigWigs:GetModule(name)
		if m:IsBossModule() and m.zonename then
			table.insert(bossModules, name)
			table.sort(bossModules)
		end
	end)

	if not StaticPopupDialogs then StaticPopupDialogs = {} end
	if not StaticPopupDialogs["ClosetGnomeBigWigsConfirm"] then
		StaticPopupDialogs["ClosetGnomeBigWigsConfirm"] = {
			text = L["%s has been enabled. Do you want to equip %s?\n\nYou can disable this confirmation dialog to autoequip with /cgbw confirm."],
			button1 = L["Equip"],
			button2 = L["Cancel"],
			sound = "levelup2",
			whileDead = 0,
			hideOnEscape = 1,
			timeout = 0,
			OnAccept = function()
				ClosetGnome:WearSet(queuedSet)
			end,
		}
	end
	
	updateAliases()
end

ClosetGnome.RegisterCallback("CGBigWigs", "AddSet", updateSets)
ClosetGnome.RegisterCallback("CGBigWigs", "DeleteSet", updateSets)
ClosetGnome.RegisterCallback("CGBigWigs", "Initialized", init)

-------------------------------------------------------------------------------
-- Events                                                                    --
-------------------------------------------------------------------------------

function addon:BigWigs_RecvSync(sync, rest, nick)
	if not BigWigs or sync ~= "EnableModule" or not rest then return end

	if not BB then BB = LibStub("LibBabble-Boss-3.0"):GetUnstrictLookupTable() end
	local translatedModuleName = BB[rest] or rest
	if not BigWigs:HasModule(translatedModuleName) then return end

	local m = BigWigs:GetModule(translatedModuleName)
	if not m or not m:IsBossModule() then return end

	local setName = self.db.char.alias[m.name]
	if not setName then return end

	if ClosetGnome:HasSet(setName) and not ClosetGnome:IsSetFullyEquipped(setName) then
		if self.db.profile.confirmEquip then
			queuedSet = setName
			StaticPopup_Show("ClosetGnomeBigWigsConfirm", "|cffd9d919"..m:ToString().."|r", "|cffd9d919"..setName.."|r")
		else
			DEFAULT_CHAT_FRAME:AddMessage(L["BigWigs module %s enabled, equipping set %s."]:format(m:ToString(), setName))
			ClosetGnome:WearSet(setName)
		end
	end
end

